function patch = blend_interpolation(patch1,patch2,overlap,x,y)
% this function blends patch1 with patch 2 with a degrade


assert(x>1|y>1, 'No blending for the first patch!');
[m,n,c] = size(patch1);
ALPHA = 1:-1/(overlap-1):0;
ALPHA = [ALPHA, zeros(1,m-overlap)]';
ALPHA = ALPHA*ones(1,n);
BETA = (1:-1/(overlap-1):0);
BETA = [BETA, zeros(1,n-overlap)];
BETA = ones(m,1)*BETA;

patch = zeros(size(patch1));

for i=1:c
    if (x>1 && y>1)
        patch(:,:,i) = (1-ALPHA).*(1-BETA).*patch2(:,:,i) + ALPHA.*BETA.*patch1(:,:,i) +...
            ALPHA.*(1-BETA).*patch1(:,:,i) + BETA.*(1-ALPHA).*patch1(:,:,i);
    else if (y==1)
            patch(:,:,i) = ALPHA.*patch1(:,:,i) + (1-ALPHA).*patch2(:,:,i);
        else if (x==1)
                patch(:,:,i) = BETA.*patch1(:,:,i) + (1-BETA).*patch2(:,:,i);
            end
        end
    end
end
    
    
    
end