% function ctrs = match_patch(patch, N);
%
% Compute N best matches to patch in squared error sense
% and return the centers(left top corner) in ctrs
%

function ctrs = match_patch(u, patch, N, norms, alpha, overlap, normsSQ, u2)

dist_mat = fourier_distance(u,patch,norms);

if (nargin == 8)
    dist_mat = alpha*dist_mat + (1-alpha)*fourier_distance(u2,overlap,normsSQ);
end

rel_dist_mat = real(dist_mat);

[~, idx] = sort(rel_dist_mat(:));
idx = idx(1:N);
j = ceil(idx./size(rel_dist_mat,1));
i = idx - (j-1)*size(rel_dist_mat,1);
ctrs = [i, j];