function w = synthLG_HF(u,v,z,wp,wo,N,k,K,r,alpha,x0,y0)
% addded parameter alpha: weights for the computing the distance between
% patches using for a scale k the information of the current scale k and
% the previous one k-1. For alpha=0 we compare patches only on the overlap
% area of the preivous scale. For alpha=1 we compare patches only on the
% whole patch of the previous scale.

[m,n,c] = size(u);

pnorms   = zeros(m,n,c);
pnorms_v = zeros(m,n,c);
pnorms_h = zeros(m,n,c);
pnorms_L = zeros(m,n,c);
for j=1:c
    mask = ones(wp);
    pnorms(:,:,j) = norm_patchesNotSquare(u(:,:,j).*u(:,:,j),wp,mask); %for initialize the first patch top-left corner
    mask_v = zeros(wp); mask_v(1:wp,1:wo) = 1;
    pnorms_v(:,:,j) = norm_patchesNotSquare(u(:,:,j).*u(:,:,j),wp,mask_v); %vertical overlap
    mask_h = zeros(wp); mask_h(1:wo,1:wp) = 1;
    pnorms_h(:,:,j) = norm_patchesNotSquare(u(:,:,j).*u(:,:,j),wp,mask_h); %hoizontal overlap
    mask_L = zeros(wp); mask_L(1:wo,1:wp) = 1; mask_L(1:wp,1:wo) = 1;
    pnorms_L(:,:,j) = norm_patchesNotSquare(u(:,:,j).*u(:,:,j),wp,mask_L); %L-shape overlap
end

norms = pnorms;

w = zeros(size(v));
[mw,nw,~] = size(v);
step = wp-wo;

if (k==(K-1))
    z = u;
end

for i=1:step:mw-wp+1
    for j=1:step:nw-wp+1
        
        if (k==(K-1) & i==1 & j==1)
            %x0 = 31;%ceil(rand*(m-wp+1));
            %y0 = 29;%ceil(rand*(n-wp+1));
            w = initializeTexture(u,wp,wo,N,r,pnorms,x0,y0);
            v = w;
        else
            
            % actual patch location being processed
            if (k==(K-1))
                v = w;
            end
            
            patch_v = v(i:i+wp-1,j:j+wp-1,:);
            patch_w = w(i:i+wp-1,j:j+wp-1,:);
            
            % assign norm respect to the overlap type
            %if k==(K-1)
                if (i==1 && j>1)
                    norms = pnorms_v;
                else if (i>1 && j==1)
                        norms = pnorms_h;
                    else if (i>1 && j>1)
                            norms = pnorms_L;
                        end
                    end
                end
            %end
            
            % ---------------------------------------------
            % 1. N NEAREST NEIGHBOURS
            % ---------------------------------------------
            if (k==(K-1) || (i==1 && j==1))
                Sp = match_patch(z,patch_v,N,norms);
            else
                overlap = w(i:i+wp-1,j:j+wp-1,:);
                Sp = match_patch(z,patch_v,N,pnorms,alpha,overlap,norms,u);
            end
            % ---------------------------------------------
            % 2. PATCH ESTIMATION USING LG MODEL
            % ---------------------------------------------
            if k==(K-1)
                Q = LGmodel(Sp, wp, u);
            else
                Q = LGmodel(Sp, wp, u-z);
            end
            % ---------------------------------------------
            % 3. BLEND PATCH INTO Is
            % ---------------------------------------------
            if i==1 && j==1
                w(1:1+wp-1,1:1+wp-1,:) = v(i:i+wp-1,j:j+wp-1,:) + Q;
            else
                if (k==K-1)
                    w(i:i+wp-1,j:j+wp-1,:) = blend_interpolation(patch_w,Q,wo,i,j);
                else
                    w(i:i+wp-1,j:j+wp-1,:) = v(i:i+wp-1,j:j+wp-1,:) + Q;
                end
            end
            
        end
        
    end
end

end
