function [w,z] = zoom_out_pyr(u,alpha)
% construit la pyramide
% u est l'image initiale, alpha le coefficient du sur-echantillonage et l
% l'chelle  laquelle on se trouve. C'est a dire, si on veut obtenir u2 a
% revient  dire que u2 = S_2(u1*G) = S_2(S_2(u0*G)*G), d'ou comme c'est
% bien echantillonnee a revient a prendre u2 = S_4(u0*G*G)

[m,n,c] = size(u);
sigma = 1.4;
kernel = fspecial('gaussian',[m n],sigma);
fftker = fft2(kernel);

z = zeros(m,n,c);
for i=1:c
    fftu = fft2(u(:,:,i));
    fftz = fftker.*fftu;
    z(:,:,i) = fftshift(ifft2(fftz));
end

w = z(1:alpha:end,1:alpha:end,:);

end